use super::*;

pub struct DefaultLayoutMut {
}

impl DefaultLayoutMut {
    pub fn new(parent: &mut CDDesc) -> Vec<LayoutMut> {
        let mut layout = Vec::new();
        
        add_dir_and_subdir(&mut layout, &mut parent.root);
        layout
    }
}

pub enum LayoutMut<'a> {
    Directory{name: &'a mut DirectoryName, properties: &'a mut Properties},
    Data(&'a mut Data)
}

fn add_dir_and_subdir<'a>(layout: &mut Vec<LayoutMut::<'a>>, dir: &'a mut Directory) {
    layout.push(LayoutMut::Directory{name: &mut dir.name, properties: &mut dir.properties});
    for data in dir.data.iter_mut() {
        layout.push(LayoutMut::Data(data));
    }

    for dir in dir.dirs.iter_mut() {
        add_dir_and_subdir(layout, dir);
    }
}
